
#include <tchar.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <math.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/timeb.h>

/******************  COMPILER strcpy_s appeasement ********************
  Need to use a # define to appease  strcpy_s
******************  ___________________ ****************************/
#ifndef   define_256_chars  
#define   define_256_chars  256
#endif 

#ifndef _Text_Manipulations_dot_h_
#define _Text_Manipulations_dot_h_


#pragma message("\n ************* ------------------------- ***********************  \n")
#pragma message("\n **             _Text_Manipulations_dot_h_                     *  \n")
#pragma message("\n **                  January, 27, 2014                         *  \n")
#pragma message("\n ************* _________________________ ***********************  \n \n \n")


unsigned char Extract_data_from_char_array_by_comma(char Original_CSV_data_array[], unsigned int comma_index, char Product_char_array[]);
int           Char_array_to_integer     (char Original_Array[] );
double long   Char_array_to_double      (char Original_Array[] );

unsigned char char_array_to_unsigned_char_array(char Source_char_array[], unsigned char Destination_unsigned_char_array[], unsigned int Array_Length);
unsigned char unsigned_char_array_to_char_array(unsigned char Source_unsigned_char_array[], char Destination_char_array[], unsigned int Array_Length);
int           String_Comp(char STD[],char UnKnown[],int len);         
//Replaces the defunct "StrCmp" function

unsigned char HEX_char_array_to_int(char input_char_array[], int &product_int);
// converts char array to an int;

unsigned char Is_Char_Hex_Value(char Single_Char);

void           Convert_unsigned_char_to_a_2_char_array(unsigned char unsigned_char, char _2_char_array[ ]);


char           Convert_nibble_to_single_char( unsigned char Nibble);



/************************* Char_array_to_integer **************************
	This function is a format converter.  The input is a "char" array of 
intergers.  The output is a simple integer.



Example:  "Original_Array"= "2345"

Returned value = 2345;
	
************************* Char_array_to_integer ***************************/


int Char_array_to_integer (char Original_Array[] )
{


  //*********************** Varible Declaration Zone ********************
  // Interger 
  int Index_j;          // Simple loop index
  int Power_Count;      // Holds the exponent+1
  int Sign=1;           //Positive or negative number
  int Number_Array[256];
  int Return_Value;     //The reported number

  //double long 
  double long Base;     // Used in power calculation
  double long Exponent; //Used in power calculation

  //******************* Varible Declaration Zone ****************************




		

			Index_j=0;
			Power_Count=-1;// Error checking 


			while ((char(0)!= Original_Array[Index_j])&&('\n'!= Original_Array[Index_j])&&(char(0)!= Original_Array[Index_j]))
			{
				
				if ( (48<= (int)Original_Array[Index_j])&&((int)Original_Array[Index_j]) <=79)
				{// NUMBER found
					Power_Count++;// 
					Number_Array[Power_Count]=((int)Original_Array[Index_j]-48);
				};// END if ( (48<= 
					
				if ( (48<= (int)Original_Array[Index_j+1])&&((int)Original_Array[Index_j+1]) <=79)
				{// NUMBER found
					if ('-'==Original_Array[Index_j])
					{
						Sign=-1;//This is a negative number.
					};// END if 
				};// END if ( (48<= 


				Index_j++;
			};// END while (' '!= Original_Array[Index_j])
			//MessageBox.Show("Power ="+Power_Count);

			//************* ERROR CHECKING **************************
			if (Power_Count<0)
			{	
				return Power_Count;	
			};// END 
			//************* ERROR CHECKING **************************


			Return_Value=0;//Initialisation
			for (Index_j=0; Index_j<=Power_Count;Index_j++)
			{
				Base=10.000;    // Used in power calculation
				Exponent=(double long)(Power_Count-Index_j);//Used in power calculation
				Return_Value=Return_Value+(Number_Array[Index_j]*((int)(pow(Base,Exponent))));	
			};// END 

			

			return (Sign*Return_Value);
};// END Char_array_to_integer (char[] Original_Array )



/************************* Char_array_to_double *************************

Converts a char array to a double. 

Caution:
"Original_Array" MUST be line feed terminated!


Example: 


  "Original_Array"= "-3.1415926736 E+23\n"

  The returend value = -3.1415926736 E+23;



      Accepts negatives,positives, "E" exponent format, and "E" exponent 
format.

 WARNING: THis function has very low tolerance of "junk" characters. By
junk characters, I mean anything other than numerals (2,8,9,4 ect),
signs ('+' and '-'), whitespace, ".", "E" and "e".


  I ahve used this function for more than 13 years. with out much 
modification.

************************* ___________________ **************************/



double long Char_array_to_double (char Original_Array[] )
{



//********************* Varible Declaration Zone ************************

// Intergers
int Index_j;                   // Simple loop index
int Index_k;                   // Simple loop index
int Numeral_Count;             // Holds the exponent+1
int Exponent_value;            // Holds the exponent
int Number_Array[10];          // Stores the numerals
int Digits_before_decimal;     // Example 234.78 Digits_before_decimal= 3
int Digits_after_decimal;      // Example 234.78 Digits_after_decimal= 2

//char varibles
char Exponent_Array[10];       // Stores exponent

//boolean varibles
bool Exponent_Found;           // Indicates of a NNNNNNeNNN exponent 
                               // was found 



//double varibles;
double long Sign;               // Positive or negative number
double long Return_Value;       // The reported number
double long Base;               // Used in power calculation
double long Exponent;           //  Used in power calculation
double long Final_Return_Value; // What is returned to summoner

bool Decimal_Point_Found ;      //Indicates that a decimal has
                                // been found 
//*********************** Varible Declaration Zone *****************************









//******************** Varible Initilisation Zone ***********************
 Index_j=0;
 Numeral_Count=-1;           // Error checking 
 Decimal_Point_Found = false;// A period has yet to be found
 Digits_before_decimal=0;    //None found yet.
 Digits_after_decimal=0;     //None found yet.
 Sign=+1.00;                 //Positive or negative number
 Exponent_value=0;           //Holds the exponent
 Digits_before_decimal=0;    //Example 234.78 Digits_before_decimal= 3
 Digits_after_decimal=0;     //Example 234.78 Digits_after_decimal= 2
 Exponent_Found = false;     //Indicates of a NNNNNNeNNN exponent 
                             // was found.

 Return_Value=0.00;          //The reported number
 Base=10.00;                 //Used in power calculation
 Exponent=0.00;              //Used in power calculation
 Decimal_Point_Found =false; // Indicates that a decimal has been found 

//******************** Varible Initilisation Zone ***********************		



//OOPS! need to accomadate two forms of exponent! "e" and "E"

// Search and replace 'E' with 'e'
Index_j=0;
while ((char(0)!= Original_Array[Index_j])&&('\n'!= Original_Array[Index_j])&&(char(13)!= Original_Array[Index_j]))
{

	if('E'==Original_Array[Index_j])
	{
					
	 Original_Array[Index_j]='e';//
	 
	}
	Index_j++;
}


			Index_j=0;

			while ((char(0)!= Original_Array[Index_j])&&('\n'!= Original_Array[Index_j])&&(char(13)!= Original_Array[Index_j])&&('e'!= Original_Array[Index_j]))
			{

				if ('.'==Original_Array[Index_j])//Decimal point found
				{
					Decimal_Point_Found = true;// A period has been found
				}

				
				
				if ( (48<= (int)Original_Array[Index_j])&&((int)Original_Array[Index_j]) <=79)
				{// NUMERAL found, count the digits 
					Numeral_Count++;// 
					Number_Array[Numeral_Count]=((int)Original_Array[Index_j]-48);

					if (false==Decimal_Point_Found)
           			{
					 Digits_before_decimal++;
				    }
					else
				    {
					 Digits_after_decimal++;
					 
				    }

				};// END  if ( (48<= (int)Orig
					
				if ( (48<= (int)Original_Array[Index_j+1])&&((int)Original_Array[Index_j+1]) <=79)
				{// NUMBER found
					if ('-'==Original_Array[Index_j])
					{
						Sign=-1.000;//This is a negative number.
						
					};// END if 
				};// END if ( (48<= 


				Index_j++;
			};// END while (' '!= Original_Array[Index_j])
			

			Index_k=0;
			if ('e'== Original_Array[Index_j])//Exponent found
			{//Exponent_Array[10]
				Exponent_Found=true;
				Index_j++;// obliterate the 'e'
				if ('+'== Original_Array[Index_j])//Exponent found
				{
					Index_j++;// obliterate the '+'
				}
				while((char(0)!= Original_Array[Index_j])&&('\n'!= Original_Array[Index_j])&&(char(13)!= Original_Array[Index_j]))
				{
					Exponent_Array[Index_k]=Original_Array[Index_j];
					Index_k++;
					Index_j++;
				}
				Exponent_Array[Index_k]='\n';//Line termination
				
			}

			Exponent_value= Char_array_to_integer (Exponent_Array );

			//************* ERROR CHECKING **************************
			if (Numeral_Count<0)
			{	
				return Numeral_Count;	
			};// END 
			//************* ERROR CHECKING **************************


			
			  Return_Value=0;//Initialisation
			  for (Index_j=0; Index_j<=Numeral_Count;Index_j++)
			  {
				Base=10.000;    // Used in power calculation
				Exponent=(double long)(Numeral_Count-Index_j);
				//Used in power calculation
				Return_Value=Return_Value+(Number_Array[Index_j]*((pow(Base,Exponent))));	
			  };// END 

			  if (Exponent_Found)
			{
				Return_Value=Return_Value*(pow(Base,(Exponent_value-Digits_after_decimal)));

				
			}else
			{

				Return_Value=Return_Value*(pow(Base,(long double)(-1.00*Digits_after_decimal)));
				
			}




			 
		

			 Final_Return_Value=Sign*Return_Value;
	
			return Final_Return_Value;
			
 }// 	double long Char_array_to_double (char Original_Array[] )








//***************** REPLACES DEFUNCT "strcmp( char[],char[]);*************************
int String_Comp(char STD[],char UnKnown[],int len)
{

	// Returns a 1 if a match is found
	// Returns a 0 if no match is found

	int parity=0; //The number of matched places
	int index;    //Loop index
      

	for(index=0; index<=len-1; index++)
	{	
		
		if (STD[index]==UnKnown[index])
		{
	     parity++;
		};//END if (STD[index]==UnKnown[index])
		
		if (len==parity)
		{ 
		 return 1;// Match
		};//END if (STD[index]==UnKnown[index]) 

		if (STD[index]!=UnKnown[index])
		{
	     parity=0;
		};//END if (STD[index]==UnKnown[index]) 
	
	};//END for(index=0; index<=len; index++)

return 0;//NO match

};//END String_Comp(char STD[],char UnKnown[],int len) 

//************ REPLACES DEFUNCT "strcmp( char[],char[]);*****************




/******************  Extract_data_from_char_array_by_comma   ************

  This function disintegrates a NULL terminated line of comma separated
varible text.
  
For example:

cOriginal_CSV_data_array ="blueberries,apples,cats,brownies,chickens,\0"

The comma index would be organised as Follows:

Comma_Index:  Value:
0             blueberries
1             apples
2             cats
3             brownies
4             chickens


Example #1:
   If you furnish comma_index=2 then "cats" is placed in 
"Product_char_array"

Example #2:
   If you furnish comma_index=4 then "chickens" is placed in 
"Product_char_array"

 
 The returned vale is an error code.  
 
 If the function exits OK, then the Error code = 0X00,other wise an error
 mesage appears.


 Input formatting requirements:

 1) The "Original_CSV_data_array" must have less than 512 chars.
 2) The total number of commas equal or exceed the value of 
    "comma_index"

 ************************** ______________________ *********************/




     unsigned char Extract_data_from_char_array_by_comma( char Original_CSV_data_array[], unsigned int comma_index, char Product_char_array[])
	 {

      

      unsigned int  Length_of_Original_Array; 
	  // Number of chars in the original array

	  unsigned int  Length_of_Refined_Array; 
	  // Number of chars in the original array

      unsigned int  byte_index;              
	  // Simple array index 

	  unsigned int  NEW_byte_index;          
	  // Array index for recently generated data snippet

      unsigned int  Comma_Count;             
	  // Number of commas in the original "Original_CSV_data_array"

      unsigned char Error_Message;           
	  // Feed back on the function per se

      unsigned int  Start_DATA_array_index;  
	  // This is the array index where the target data starts.

	  unsigned int  Finnish_DATA_array_index;
	  // This is the array index where the target data finnishes.

	  unsigned char Start_DATA_detected;     
	  // This is the array index where the target data starts.

	  unsigned char Finnish_DATA_detected;   
	  // This is the array index where the target data finnishes.

      
	  char          Refined_Data_array[4096]; 
	  // This is a copy of  "Original_CSV_data_array" minus white space.
     

      strcpy_s(Product_char_array,define_256_chars,"Extract_Data_by_Comma_JUNK_DATA");

	

      Error_Message =0X00;


        Length_of_Original_Array = strlen(Original_CSV_data_array);//


     //********* Test the original length of the array  *******************

   

      if ((0==Length_of_Original_Array) || (4096 < Length_of_Original_Array))
	  {  
         Error_Message = Error_Message | 0X01;// Not valid request for 

		 fprintf(stderr, "Length_of_Original_Array =%i\n",Length_of_Original_Array); 

	  }  

      
	 //********** Test the original length of the array  ******************


	  



      //********* calculate the number of commas in the original array ***********
      Comma_Count=0;// None detected yet
      for (byte_index=0;byte_index<Length_of_Original_Array;byte_index++)
	  { 

        if (','==Original_CSV_data_array[byte_index])
		{
         Comma_Count++;
		}      
     
	  }
	  //********** ___________________________________________________ *********





       if (Comma_Count-1 < comma_index )// ERROR alert
	   {
          Error_Message = Error_Message | 0X02;
		  // Not valid request for data extraction 

	   }
     

 

	    if (Comma_Count == 0)// ERROR alert
	   {
         Error_Message = Error_Message | 0X04;// Comma count is not valid

	   }
      

	
      if (0X00!=Error_Message)
	  {

		 printf( ">>>>>> ERROR! ''Extract_data_from_char_array_by_comma'' rejected on your data!!! <<<<<<<<\n"); 


		 return Error_Message;
	  }


 /********************** Refined_Data_array generation ****************** 

 The data extration must accept an arbitrary arrangement of whitespace. I
have no control of the arrangement of the input data. This whitespace is 
a blight that must be removed. 

************* _____________________________ ****************************/


     NEW_byte_index=0;
	  for (byte_index=0; byte_index< Length_of_Original_Array;byte_index++)
	  {

		  if (' '!=Original_CSV_data_array[byte_index])
		  {
           Refined_Data_array[NEW_byte_index]  = Original_CSV_data_array[byte_index]; 
		   Refined_Data_array[NEW_byte_index+1] = ',';//Comma termination
		   Refined_Data_array[NEW_byte_index+2] = ',';//NUL termination
		   Refined_Data_array[NEW_byte_index+3] = ',';//Comma termination
		   Refined_Data_array[NEW_byte_index+4] = '\0';//NUL termination
		   NEW_byte_index++;
		  }
         

	  }



      Length_of_Refined_Array = strlen (Refined_Data_array);








	  //******** calculate the data index of the start ad stop points  ******
      Comma_Count=0;// None detected yet
	  Start_DATA_detected =0X00;
	  Finnish_DATA_detected =0X00;

	  Start_DATA_array_index=0;
	  Finnish_DATA_array_index=0;



	 
      for (byte_index=0;byte_index<Length_of_Refined_Array;byte_index++)
	  { 

	
		if ((Comma_Count == comma_index) &&(0X00 == Start_DATA_detected))
		 {
            Start_DATA_array_index = byte_index;
			Start_DATA_detected =0X01;
		 }


         if ((Comma_Count == (comma_index+1)) &&(0X00 == Finnish_DATA_detected))
		 {
            Finnish_DATA_array_index = byte_index;
			Finnish_DATA_detected =0X01;
		 }

          if (','==Refined_Data_array[byte_index])
		  {
            Comma_Count++;
		  }

		
     
	  }

      
      //*********** _______________________________________ *************


	  


	  NEW_byte_index =0;


       for ((byte_index=Start_DATA_array_index);byte_index<(Finnish_DATA_array_index-1);byte_index++ )
	   {


		    Product_char_array[NEW_byte_index] =Refined_Data_array[byte_index];

		    Product_char_array[NEW_byte_index+1]='\0';//NULL terminator


			NEW_byte_index++;


	   }

	     Product_char_array[NEW_byte_index+2]='\n';

	   


     return Error_Message;



	 };//END  unsigned char Extract_data_from_char_array_by_comma(...)



	 unsigned char unsigned_char_array_to_char_array(unsigned char  Source_unsigned_char_array[], char Destination_char_array[], unsigned int Array_Length)
	 {
        unsigned char reply_message=0;
		unsigned int   byte_index;

		 for (byte_index=0;byte_index<Array_Length;byte_index++)
		 {
          Destination_char_array[byte_index] = (char) Source_unsigned_char_array[byte_index];
		 }

        return reply_message;
	 }

    

    unsigned char char_array_to_unsigned_char_array(char Source_char_array[], unsigned char Destination_unsigned_char_array[], unsigned int Array_Length)
	{

		unsigned char reply_message=0;
		unsigned int   byte_index;

		 for (byte_index=0;byte_index<Array_Length;byte_index++)
		 {
          Destination_unsigned_char_array[byte_index] = (unsigned char) Source_char_array[byte_index];
		 }

        return reply_message;
	}



/************************* HEX_char_array_to_int*************************

Basic task:  Converts a hex asci array to an int.  

Entity:             Translation:
"input_char_array"  An arrray that might contain some hex data.
"product_int"       Product int. This is a negative number if there
                    was an error.

"Reply_Value"      =0X00 if function worked as expected.



************************* _____________________*************************/


unsigned char HEX_char_array_to_int(char input_char_array[], int &product_int)
{
    unsigned char Reply_Value;
	unsigned char HEX_conversion;
	unsigned char First_X_detected_flag;

	int           Length_of_input_array;
	int           Length_of_purged_array;
	int           char_index;
	int           index_position_of_first_X_symbol;
    int           number_of_X_chars_detected;
	int           nibble_index;
	int           bit_shift;

	char          Purged_array[256];
	//"input_char_array" with only valid HEX chars

	char          Single_char;



	Reply_Value =0X00;// All ok so far.



	


    Length_of_input_array = strlen(input_char_array);

	if (0==Length_of_input_array)
	{
		
        printf("******            _______FUMTU ALERT______               *******\n\n");
		printf("* NO valid data to ''HEX_char_array_to_int''                  **\n\n");
		printf("******           _______FUMTU ALERT______                 *******\n\n");
		
	   product_int = -9999;//Error code
       Reply_Value =0X01;
	  return Reply_Value;
	}

	//*************** PURGE NON HEX VALUES *********************************
    Length_of_purged_array =0;
	for (char_index=0;char_index<Length_of_input_array;char_index++)
	{
      Single_char = input_char_array[char_index];
	 
	  HEX_conversion = Is_Char_Hex_Value(Single_char);


	  if (0X10!=HEX_conversion)
	  {//Valid_Hex_Found
		  
		  Purged_array[Length_of_purged_array]=Single_char;
          Length_of_purged_array++;
	  }

	}
	//*************** __________________ *******************************



	//printf("Purged_array=%s\n",Purged_array);
 


   //*************** Search for 1st X symbol if any *********************
   First_X_detected_flag =0X00;
   number_of_X_chars_detected =0;
   for (char_index=0;char_index<Length_of_purged_array;char_index++)
   {
	   Single_char = Purged_array[char_index];
	   HEX_conversion = Is_Char_Hex_Value(Single_char);
	   if (0X20==HEX_conversion)//'X'-or-'x' detected
	   {
         if (0X00==First_X_detected_flag)
		 {// First X detected
           index_position_of_first_X_symbol = char_index;
           First_X_detected_flag =0XFF;
		 }
	    number_of_X_chars_detected++;
	   }
   }

   if (0X00==First_X_detected_flag)
   {
     index_position_of_first_X_symbol = 0;
   }

   //*************** _______________________________ ********************


   // ERROR checking 
   if (1<number_of_X_chars_detected)
   {
        printf("******            _______FUMTU ALERT______               *******\n\n");
		printf("* Malformed data has bee delivered to ''HEX_char_array_to_int''**\n\n");
		printf("* ''input_char_array''=%s \n\n",input_char_array);
		printf("*            Excessive ''X'' or ''x'' symbols                  **\n\n");
		printf("******           _______FUMTU ALERT______                 *******\n\n");
		Reply_Value =0X02;
        product_int = -9999;//Error code
		return Reply_Value;
   }


  product_int =0;
  for (char_index=(Length_of_purged_array-1);char_index>index_position_of_first_X_symbol;char_index--)
   {

	  Single_char = Purged_array[char_index];

	   //printf("* ''Single_char''=%c \n\n",Single_char);
	  HEX_conversion = Is_Char_Hex_Value(Single_char);
	 

      nibble_index = (Length_of_purged_array-char_index-1);
	  bit_shift    =  nibble_index *4;

	  product_int = product_int + (HEX_conversion<<bit_shift);
	
	 
  }

    //printf("* ''product_int''=%i \n\n",product_int);


     return Reply_Value;
}



/**************************  Is_Char_Hex_Value ****************************

  Want to determine if the "Single_Char" represents a hex number.



Entity:             Translation:
"Single_Char"       Single input char;

"Reply_Value"       Represents an unsigned char of a valid hex value.
                    If "Single_Char" is not a valid value then 0X10 is
					returned. 

					 If "Single_Char" is 'X'-or-'x' a valid value then 0X20 
					 is returned. 

*********************  Is_Char_Hex_Value *********************************/

unsigned char Is_Char_Hex_Value(char Single_Char)
{
unsigned char Reply_Value;

Reply_Value =0X10;


   if ('0'==Single_Char)
   {
	 return 0X00;
   }

   if ('1'==Single_Char)
   {
	 return 0X01;
   }
	
   if ('2'==Single_Char)
   {
	 return 0X02;
   }

   if ('3'==Single_Char)
   {
	 return 0X03;
   }

   
   if ('4'==Single_Char)
   {
	 return 0X04;
   }

   if ('5'==Single_Char)
   {
	 return 0X05;
   }
	
   if ('6'==Single_Char)
   {
	 return 0X06;
   }

   if ('7'==Single_Char)
   {
	 return 0X07;
   }

   if ('8'==Single_Char)
   {
	 return 0X08;
   }

    if ('9'==Single_Char)
   {
	 return 0X09;
   }

   if ('A'==Single_Char)
   {
	 return 0X0A;
   }

   if ('B'==Single_Char)
   {
	 return 0X0B;
   }

   if ('C'==Single_Char)
   {
	 return 0X0C;
   }

    if ('D'==Single_Char)
   {
	 return 0X0D;
   }

   if ('E'==Single_Char)
   {
	 return 0X0E;
   }

    if ('F'==Single_Char)
   {
	 return 0X0F;
   }

	if ('a'==Single_Char)
   {
	 return 0X0A;
   }

   if ('b'==Single_Char)
   {
	 return 0X0B;
   }

   if ('c'==Single_Char)
   {
	 return 0X0C;
   }

    if ('d'==Single_Char)
   {
	 return 0X0D;
   }

   if ('e'==Single_Char)
   {
	 return 0X0E;
   }

    if ('f'==Single_Char)
   {
	 return 0X0F;
   }


	
   if ('X'==Single_Char)
   {
	 return 0X20;
   }

    if ('x'==Single_Char)
   {
	 return 0X20;
   }

return Reply_Value;

}

char Convert_nibble_to_single_char( unsigned char Nibble)
{

	char reply_char;
   Nibble = 0X0F&Nibble;
   reply_char ='G';//Error code 

   if (0X00==Nibble)
   {
      reply_char ='0';

   }


   if (0X01==Nibble)
   {
      reply_char ='1';

   }


	if (0X02==Nibble)
   {
      reply_char ='2';

   }

	if (0X03==Nibble)
   {
      reply_char ='3';

   }


	 if (0X04==Nibble)
   {
      reply_char ='4';

   }


   if (0X05==Nibble)
   {
      reply_char ='5';

   }

	if (0X06==Nibble)
   {
      reply_char ='6';

   }

    if (0X07==Nibble)
   {
      reply_char ='7';

   }

    if (0X08==Nibble)
   {
      reply_char ='8';

   }


	 if (0X09==Nibble)
   {
      reply_char ='9';

   }


   if (0X0A==Nibble)
   {
      reply_char ='A';

   }


	if (0X0B==Nibble)
   {
      reply_char ='B';

   }

	if (0X0C==Nibble)
   {
      reply_char ='C';

   }


	 if (0X0D==Nibble)
   {
      reply_char ='D';

   }


   if (0X0E==Nibble)
   {
      reply_char ='E';

   }

	if (0X0F==Nibble)
   {
      reply_char ='F';

   }

  

	return reply_char;



}

void Convert_unsigned_char_to_a_2_char_array(unsigned char unsigned_char, char _2_char_array[ ])
{

	unsigned char High_nibble;
	unsigned char Low_nibble;

	char          High_nibble_char;  
	char          Low_nibble_char;  
	// Convert_nibble_to_single_char( unsigned char Nibble);

	High_nibble = (0XF0&unsigned_char)>>4;
	Low_nibble  = (0X0F&unsigned_char);

     
	High_nibble_char =  Convert_nibble_to_single_char( High_nibble);

	Low_nibble_char =  Convert_nibble_to_single_char( Low_nibble);


	 _2_char_array[0]= High_nibble_char;

	 _2_char_array[1]= Low_nibble_char;

	  _2_char_array[2]= '\0';


    return;//nothing
}


#endif








/************* LEGAL CYA ***********************************************
	
1)  (I/we/us) make no expressed warranties or implied warranties 
   what-so-ever on the fitness or merchantability of this software for 
   any purpose.

2)   By using this software, you accept any and all liability and risk 
   associated with the use of this software.

3)  This software may NEVER be used in any shape form or 
    fashion that will result in: 
   
    A) Personal injury
    B) Economic damage
    C) Criminal activity
    D) Any circumstance that might enable a plaintifs lawyer to
	   sue (I/we/us) for criminal or civil penalties.

       
4)  Any use of this software is contingent on the indisputable fact 
   that anyone who uses this software accepts this software "AS-IS".

5)  Any re-transmission of this software MUST contain ALL of the 
   legal CYA text in the original unaltered form.  
************* LEGAL CYA ************************************************/