// MAXIM_DS2482.cpp : Defines the entry point for the console application.
//
#ifndef _CRT_SECURE_NO_WARNINGS 
#define _CRT_SECURE_NO_WARNINGS
#pragma message("\n ************* ------------------------- ***********************  \n")
#pragma message("\n **    COMPILER WARNING FUNCTION DEACTIVATED                   *  \n")
#pragma message("\n **              January, 2, 2014                              *  \n")
#pragma message("\n ************* _________________________ ***********************  \n \n \n")
#endif


#include <iostream>

#include "Text_Manipulations.h"
#include "VISA_GPIB_manager.h"
#include "Agilent_34401A_GPIB_22.h"
#include "Engineering_File_Writer_IO_class.h"
#include "Time_Stamp.h"


using namespace std;

unsigned char MISO_SDO_bit;




int main()
{

	  unsigned int EXCEL_loop_iteration; 
	  double       Agilent_22_voltage;
	  double long  Time_zero;
	  double long  Time_NOW;



	  Engineering_File_Writer_IO_class CSV_File_writer;

	  Agilent_34401A_Init_GPIB_22( );


  //********** Mysterious time functions ***********
  time_t rawtime; //Oooh! Gah Boo! Gah!           //
  struct tm * timeinfo;//Abra cadabra             //
  char Mystery_time_buffer [256];                 //
  time (&rawtime);                                //
  timeinfo = localtime (&rawtime);                //
  //********** Mysterious time functions ***********

 strftime (Mystery_time_buffer,256,"Execution Date: (%A) %c",timeinfo);
 
  fprintf(stderr,"Mystery_time_buffer=%s\n",Mystery_time_buffer);

   system("color 0C");
   Sleep(500);
   system("color 03");
   Sleep(500);
   system("color 0C");

 


	
	  Time_zero = TIME_Stamp_mS();


	   CSV_File_writer.File_Open("Equipment_Test.csv");
	   CSV_File_writer.Write_char_array_to_file("Time,Agilent_22_voltage,\n");


	 for (EXCEL_loop_iteration=0;EXCEL_loop_iteration<30000;EXCEL_loop_iteration++)
	 {

		Time_NOW = (TIME_Stamp_mS())-Time_zero;
		Agilent_22_voltage  = Agilent_34401A_Fetch_DUT_DC_Voltage_GPIB_22();


			system("cls");
			fprintf(stderr, "EXCEL_loop_iteration=%E\n",EXCEL_loop_iteration);


			fprintf(stderr, "Time_NOW=%E\n",Time_NOW);
			fprintf(stderr, "Agilent_22_voltage=%E\n",Agilent_22_voltage);
          
			

			CSV_File_writer.Write_double_to_file(Time_NOW);
			CSV_File_writer.Write_comma_to_file();

			CSV_File_writer.Write_double_to_file(Agilent_22_voltage);
			CSV_File_writer.Write_comma_to_file();
		

			CSV_File_writer.Write_newline_to_file();

	 }

	fprintf(stderr,"Tap any key and  despair your existance.......\n");
	getchar();

	return 0;

};//END int main()






